//+------------------------------------------------------------------+
//|                                                 FFCal_EA_v01.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string FFCalName="FFCal_v03_mod_v1.1";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  
   double newsIdx;
   double newsTime;// NewsDateTime,GMT	
   double Impact;
   double Previous;
   double Forecast;   
   double minsTillNews = find_first_news_time(newsIdx, newsTime, Impact, Previous, Forecast);
   Print("minsTillNews:",minsTillNews,"  newsIdx:",newsIdx,"  newsTime:",newsTime," impact: ",Impact," Previous: ",Previous," Forecast: ",Forecast);   
   
   double GMTdiffServer=get_global1();
   double GMTdiffLocal=get_global2();   
   Print("_GMTdiffServer:",GMTdiffServer,"  _GMTdiffLocal:",GMTdiffLocal);
   
   Print("ServerNewsTime:",TimeToStr(newsTime+GMTdiffServer*3600,TIME_DATE|TIME_MINUTES));

//----
   return(0);
  }

//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
double find_first_news_time(double &newsIdx, double &newsTime, double &Impact, double &Previous, double &Forecast)
{
  double valbuff0;

  double valbuff3;
  double valbuff4;
  double valbuff5;
  double valbuff6;
  double valbuff7;            
  
  for (int i=0;i<=200;i++)
  { 
    valbuff0=iCustom(Symbol(),0,FFCalName,0,i);//ExtMapBuffer0[newsIdx] = minsTillNews;
    valbuff3=iCustom(Symbol(),0,FFCalName,3,i);//ExtMapBuffer3[newsIdx] = newsIdx;  // newsIdx
    valbuff4=iCustom(Symbol(),0,FFCalName,4,i);//ExtMapBuffer4[newsIdx] = newsTime;  // NewsDateTime,GMT
    valbuff5=iCustom(Symbol(),0,FFCalName,5,i);//ExtMapBuffer5[newsIdx] = ImpactToNumber(mainData[newsIdx][IMPACT]);  // Impact
    valbuff6=iCustom(Symbol(),0,FFCalName,6,i);//ExtMapBuffer6[newsIdx] = PreviousToNumber(mainData[newsIdx][PREVIOUS]);//
    valbuff7=iCustom(Symbol(),0,FFCalName,7,i);//ExtMapBuffer7[newsIdx] = ForecastToNumber(mainData[newsIdx][FORECAST]);//

    if (valbuff0>=0)
    {
      newsIdx=valbuff3; 
      newsTime=valbuff4;  
      Impact=valbuff5;
      Previous=valbuff6;
      Forecast=valbuff7;
      return(valbuff0);
    }  
  }
  return(-1);
}

//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
double get_global1()
{
        double r1;
        string Global1 = /*Symbol() + */"_GMTdiffServer";
        if (GlobalVariableCheck(Global1))
          r1=GlobalVariableGet(Global1);
        else
          r1=0;  
        return(r1);
}

//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
double get_global2()
{
         double r2;
         string Global2 = /*Symbol() +*/ "_GMTdiffLocal";
         if (GlobalVariableCheck(Global2))
           r2=GlobalVariableGet(Global2);
         else
           r2=0;  
         return(r2);
}

